<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport"
          content="width=device-width, user-scalable=no, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0">
    <title>Hello WebXR!</title>
    <link rel="stylesheet" type="text/css" href="main.css">
    <!-- three.js -->
    <script src="https://unpkg.com/three@0.126.0/build/three.js"></script>
    <!-- Add the GLTF model loader. -->
    <script src="https://unpkg.com/three@0.126.0/examples/js/loaders/GLTFLoader.js"></script>
</head>
<body>
<!-- Starting an immersive WebXR session requires user interaction. We start this one with a simple button. -->
<button id="startButton">Start Hello WebXR</button>
<script>
    const $startButton = document.getElementById('startButton');

    const activateXR = async () => {
        // Add a canvas element and initialize a WebGL context that is compatible with WebXR.
        const $canvas = document.createElement('canvas');
        document.body.appendChild($canvas);

        const gl = $canvas.getContext('webgl', {
            'xrCompatible': true
        });

        // // Creating a Three.js scene for rendering a cube.
        // const scene = new THREE.Scene();
        //
        // // The cube will have a different color on each side.
        // const materials = [
        //     new THREE.MeshBasicMaterial({'color': 0xff0000}),
        //     new THREE.MeshBasicMaterial({'color': 0x0000ff}),
        //     new THREE.MeshBasicMaterial({'color': 0x00ff00}),
        //     new THREE.MeshBasicMaterial({'color': 0xff00ff}),
        //     new THREE.MeshBasicMaterial({'color': 0x00ffff}),
        //     new THREE.MeshBasicMaterial({'color': 0xffff00})
        // ];
        //
        // // Create the cube and add it to the demo scene.
        // const cube = new THREE.Mesh(new THREE.BoxBufferGeometry(0.2, 0.2, 0.2), materials);
        //
        // cube.position.set(1, 1, 1);
        //
        // scene.add(cube);

        // Creating a Three.js scene for placing a sunflower.
        const scene = new THREE.Scene();

        const directionalLight = new THREE.DirectionalLight(0xffffff, 0.3);
        directionalLight.position.set(10, 15, 10);
        scene.add(directionalLight);

        // Set up the WebGLRenderer, which handles rendering to the session's base layer.
        const renderer = new THREE.WebGLRenderer({
            'alpha': true,
            'preserveDrawingBuffer': true,
            'canvas': $canvas,
            'context': gl
        });

        renderer.autoClear = false;

        // The API directly updates the camera matrices.
        // Disable matrix auto updates so three.js doesn't attempt to handle the matrices independently.
        const camera = new THREE.PerspectiveCamera();
        camera.matrixAutoUpdate = false;

        // Initialize a WebXR session using "immersive-ar".
        const session = await navigator.xr.requestSession('immersive-ar', {
            'requiredFeatures': ['hit-test']
        });

        session.updateRenderState({
            'baseLayer': new XRWebGLLayer(session, gl)
        });

        // A 'local' reference space has a native origin that is located
        // near the viewer's position at the time the session was created.
        const referenceSpace = await session.requestReferenceSpace('local');

        // Create another XRReferenceSpace that has the viewer as the origin.
        const viewerSpace = await session.requestReferenceSpace('viewer');
        // Perform hit testing using the viewer as origin.
        const hitTestSource = await session.requestHitTestSource({space: viewerSpace});

        // Load the GLTF model.
        const loader = new THREE.GLTFLoader();

        let reticle;
        let model;

        loader.load('https://immersive-web.github.io/webxr-samples/media/gltf/reticle/reticle.gltf', function (gltf) {
            reticle = gltf.scene;
            reticle.visible = false;

            scene.add(reticle);
        });

        loader.load('https://immersive-web.github.io/webxr-samples/media/gltf/sunflower/sunflower.gltf', gltf => {
            model = gltf.scene;
        });

        // Add event listener to the session for placing the sunflower.
        session.addEventListener('select', event => {
            if (!model) return;

            const clone = model.clone();

            clone.position.copy(reticle.position);
            scene.add(clone);
        });

        // Create a render loop that allows us to draw on the AR view.
        const onXRFrame = (time, frame) => {
            // Queue up the next draw request.
            session.requestAnimationFrame(onXRFrame);

            // Bind the graphics framebuffer to the baseLayer's framebuffer
            gl.bindFramebuffer(gl.FRAMEBUFFER, session.renderState.baseLayer.framebuffer)

            // Retrieve the pose of the device.
            // XRFrame.getViewerPose can return null while the session attempts to establish tracking.
            const pose = frame.getViewerPose(referenceSpace);

            if (pose) {
                // In mobile AR, we only have one view.
                const view = pose.views[0];
                const viewport = session.renderState.baseLayer.getViewport(view);

                renderer.setSize(viewport.width, viewport.height)

                // Use the view's transform matrix and projection matrix to configure the THREE.camera.
                camera.matrix.fromArray(view.transform.matrix)
                camera.projectionMatrix.fromArray(view.projectionMatrix);
                camera.updateMatrixWorld(true);

                // Expose interactions with real world geometry.
                const hitTestResults = frame.getHitTestResults(hitTestSource);

                if (hitTestResults.length > 0 && reticle) {
                    const hitPose = hitTestResults[0].getPose(referenceSpace);

                    reticle.visible = true;
                    reticle.position.set(hitPose.transform.position.x, hitPose.transform.position.y, hitPose.transform.position.z)
                    reticle.updateMatrixWorld(true);
                }

                // Render the scene with THREE.WebGLRenderer.
                renderer.render(scene, camera)
            }
        }

        // Start the render loop.
        session.requestAnimationFrame(onXRFrame);
    }

    // Start the XR function.
    $startButton.onclick = activateXR;
</script>
</body>
</html>